/*****************************************************************************/
/* Software Testing Automation Framework (STAF)                              */
/* (C) Copyright IBM Corp. 2002                                              */
/*                                                                           */
/* This software is licensed under the Common Public License (CPL) V1.0.     */
/*****************************************************************************/

package com.ibm.staf.service.cron;

import java.util.*;

public class CronData implements java.io.Serializable
{
    // CAUTION!  Adding fields to this class will make older versions of the 
    // serialized class incompatible with the new version.  If a new field
    // is required for this class, then create a new class with the new field,
    // called CronData1, and if the serialized file being read in during 
    // service startup is of object type CronData, then read it in and convert
    // it into object type CronData1.

    String fOriginMachine;
    String fMachine;
    boolean fPythonMachine = true;
    String fService;
    boolean fPythonService = true;
    String fRequest;
    boolean fPythonRequest = true;
    String fPrepare;
    Vector fMinute = new Vector();
    Vector fHour = new Vector();
    Vector fDay = new Vector();
    Vector fMonth = new Vector();
    Vector fWeekday = new Vector();

    public CronData()
    {
     super();
    }

    public CronData(String originMachine, String machine, 
                    boolean pythonMachine, String service, 
                    boolean pythonService, String request, 
                    boolean pythonRequest, String prepare,
                    Vector minute, Vector hour, Vector day,
                    Vector month, Vector weekday)
    {
        this.fOriginMachine = originMachine;
        this.fMachine = machine;
        this.fPythonMachine = pythonMachine;
        this.fService = service;
        this.fPythonService = pythonService;
        this.fRequest = request;
        this.fPythonRequest = pythonRequest;
        this.fPrepare = prepare;
        this.fMinute = minute;
        this.fHour = hour;
        this.fDay = day;
        this.fMonth = month;
        this.fWeekday = weekday;
    }
}