/*****************************************************************************/
/* Software Testing Automation Framework (STAF)                              */
/* (C) Copyright IBM Corp. 2002                                              */
/*                                                                           */
/* This software is licensed under the Common Public License (CPL) V1.0.     */
/*****************************************************************************/

package com.ibm.staf.service.stax;

public class STAXRethrowAction implements STAXAction
{
    public STAXRethrowAction()
    { /* Do Nothing */ }

    public String getXMLInfo()
    {
        return "<rethrow/>";
    } 

    public String getInfo()
    {
        return "";
    }

    public String getDetails()
    {
        return "";
    }

    public void execute(STAXThread thread)
    {
        thread.popAction();
        thread.addCondition(new STAXRethrowExceptionCondition());
    }

    public void handleCondition(STAXThread thread, STAXCondition cond)
    {
        thread.popAction();
    }

    public STAXAction cloneAction()
    {
        return new STAXRethrowAction();
    }
}
