/*****************************************************************************/
/* Software Testing Automation Framework (STAF)                              */
/* (C) Copyright IBM Corp. 2004                                              */
/*                                                                           */
/* This software is licensed under the Common Public License (CPL) V1.0.     */
/*****************************************************************************/

#ifndef STAF_ZIPFileHeader
#define STAF_ZIPFileHeader


class STAFZipFileHeader
{
public:

    uLong signature;

    short versionMadeBy;

    short versionNeededToExtract;

    short generalPurposeBitFlag;

    short compressionMethod;

    uLong lastModifiedTimeDate;

    uLong crc;

    uLong compressedSize;

    uLong uncompressedSize;

    short fileNameLength;

    short extraFieldLength;

    short fileCommentLength;

    short diskNumberStart;

    short internalFileAttributes;

    uLong externalFileAttributes;

    uLong localFileHeaderOffset;

    char *fileName;

    void *extraField;

    char *fileComment;

    uLong size;


    // methods

    STAFZipFileHeader();

    STAFZipFileHeader(void*);


    ~STAFZipFileHeader();
};

#endif
