/*****************************************************************************/
/* Software Testing Automation Framework (STAF)                              */
/* (C) Copyright IBM Corp. 2001                                              */
/*                                                                           */
/* This software is licensed under the Common Public License (CPL) V1.0.     */
/*****************************************************************************/

#ifndef STAF_ShutdownService
#define STAF_ShutdownService

#include "STAFService.h"
#include "STAFCommandParser.h"

class STAFShutdownService : public STAFService
{
public:

    STAFShutdownService();

    virtual STAFServiceResult acceptRequest(
                              const STAFServiceRequest &requestInfo);

    virtual STAFString info(unsigned int raw = 0) const;

    virtual ~STAFShutdownService();

private:

    // Don't allow copy construction or assignment
    STAFShutdownService(const STAFShutdownService &);
    STAFShutdownService &operator=(const STAFShutdownService &);

    STAFServiceResult handleShutdown(const STAFServiceRequest &requestInfo);
    STAFServiceResult handleNotifyRegistration(
                          bool isRegister,
                          const STAFServiceRequest &requestInfo);
    STAFServiceResult handleNotifyList(const STAFServiceRequest &requestInfo);
    STAFServiceResult handleHelp(const STAFServiceRequest &requestInfo);

    STAFCommandParser fShutdownParser;

    STAFMapClassDefinitionPtr fNotifieeClass;
};

#endif
